#include "interfSegmentationMenu.h"
#include "interfMainPanel.h"

interfSegmentationMenu::interfSegmentationMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: interfMenuBar(parent, sizex, sizey)
{
	this->datadir = datdir;
	//contourevent = (wxContourEventHandler*)evtHandler;
	infoWin = NULL;
	configPanel = NULL;
	spreadPanel = NULL;
	segmentPanelITK = NULL;
	
	//eventHandler = evtHandler;

	initButtons(this);
}

void interfSegmentationMenu::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/Segmentation.png");
	nom.push_back("Find shapes by automatic segmentation");
	funct.push_back((wxObjectEventFunction) &interfSegmentationMenu:: onSegmentationPressed);

	path.push_back(datadir + "/ITK.png");
	nom.push_back("Find shapes by automatic segmentation with ITK");
	funct.push_back((wxObjectEventFunction) &interfSegmentationMenu:: onSegmentationPressedITK);

	path.push_back(datadir + "/snake.png");
	nom.push_back("Find shapes using border snake interaction");
	funct.push_back((wxObjectEventFunction) &interfSegmentationMenu:: onSnakePressed);

	path.push_back(datadir + "/Mirror.png");
	nom.push_back("Create an Axis and select a contour to mirror it accordingly");
	funct.push_back((wxObjectEventFunction) &interfSegmentationMenu:: onMirrorPressed);

	path.push_back(datadir + "/Threshold.png");
	nom.push_back("Superpose a 'Red Image' to the selected Image Threshold");
	funct.push_back((wxObjectEventFunction)&interfSegmentationMenu::onThreshold);

	this->addButtons(path, nom);	
	this->setVectorFunction(funct);

	this->connectEvents(evtHandler);
	   

}

interfSegmentationMenu::~interfSegmentationMenu()
{
}

/**
	**	Responds to the events of the buttons, when the same panel is responsible for it. It gets the name
	**	of the button corresponding to the method that has to be executed,
	**	it uses attribute eventHandler to call the methods define by the application.
	**	see setEventHandler(wxEventHandler*)
	**/


void  interfSegmentationMenu::onSegmentationPressed(wxCommandEvent& event){

	interfMainPanel::getInstance()->onSegmentationPressed();
}



void  interfSegmentationMenu::onSegmentationPressedITK(wxCommandEvent& event){

	interfMainPanel::getInstance()->onSegmentationPressedITK();

    
}

void  interfSegmentationMenu::onSnakePressed(wxCommandEvent& event){
    
	interfMainPanel::getInstance()->onSnakePressed();

}

void interfSegmentationMenu::onMirrorPressed(wxCommandEvent& event){

  interfMainPanel::getInstance()->onMirrorPressed();

}

void interfSegmentationMenu::onThreshold(wxCommandEvent& event){
	
	interfMainPanel::getInstance()->onThresholdPressed();

}

//------------------------------------------------------------------------------------------------------------

