#ifndef __IMAGE_SECTION_THING__
#define __IMAGE_SECTION_THING__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>
#include "vtkImageData.h"

class ImageSectionThing{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:


	/*
	* Creates the section image with the given image
	* @param sourceImage The image data to set.
	*/
	ImageSectionThing(vtkImageData * theImage);

	/*
	* Destroys the image section
	*/
	~ImageSectionThing();

//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Gets the image data 
	* @return image The image.
	*/
	vtkImageData * getImageData();

	/*
	* Sets the source image 
	* @param theImage The image to set.
	*/
	void setImageData( vtkImageData *  theImage);

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------

	vtkImageData * image;

};
#endif
