
//----------------------------------------------------------------------------------------------------------------
// Class definition include
//----------------------------------------------------------------------------------------------------------------
#include "NameWrapper.h"

//----------------------------------------------------------------------------------------------------------------
// Class implementation
//----------------------------------------------------------------------------------------------------------------
/** @file NameWrapper.cxx */

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------

	/*
	* Creates the NameWrapper
	* @param thekeyName The key name
	* @param theRealName  The real name
	* @return Returns the created NameWrapper 
	*/
	NameWrapper :: NameWrapper(std::string thekeyName, std::string theRealName)
	{
		setWrappingPair(thekeyName, theRealName);
	}

	/*
	* Destroys the NameWrapper
	*/
	NameWrapper :: ~ NameWrapper()
	{

	}

//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Sets the names pair to wrapp
	* @param thekeyName The key name
	* @param theRealName  The real name
	*/
	void NameWrapper :: setWrappingPair(std::string thekeyName, std::string theRealName )
	{
		realName = theRealName;
		keyName = thekeyName;
	}

	/*
	* Gets the wrapped key name
	* @param keyName The key name
	*/
	std::string NameWrapper :: getKeyName()
	{
		return keyName;
	}

	/*
	* Gets the wrapped real name
	* @param realName The real name
	*/
	std::string NameWrapper :: getRealName()
	{
		return realName;
	}
 
 
